###########################################################################
library(foreign)
clothing = read.dta("clothing.dta" );
attach(clothing); 
 
y = log(tsales)
N = length(y)
x1 = log(hoursw)
x2 = log(ssize)
Xmat = cbind(x1,x2)
p=ncol(Xmat)

# Initialization 
alpha_hat = mean(y)
f1_hat = rep(0,N)
f2_hat = rep(0,N)
f_hat  = cbind(f1_hat, f2_hat)

for (k in 1:20)
{
  for (j in 1:p)
  {
    if (p>2) fmj_hat = apply(f_hat[,-j],1,sum) else fmj_hat = f_hat[,-j]
    e  = y - alpha_hat-fmj_hat
    x  = Xmat[,j]
    xs = smooth.spline(x, e, cv = T)  
    pred = predict(smooth.spline(x, e, cv = T), x) 
    f_hat[,j] = pred$y-mean(pred$y)
  }
  
}
windows()
plot(x1, y)
lines(x1, alpha_hat+f_hat[,1], type = "p",  col = 2) 
plot(x2, y)
lines(x2, alpha_hat+f_hat[,2], type = "p",  col = 2) 
 
